(* Written by:      Sergej Srepfler             ( repfler in CP852)
                    (c) 1995 V 0.4
                    Adress:  V. Nazora 19
                             31551 Belisce      ( Belie in CP852)
                             Croatia
                    E-mail:  sergej@osijek.etfos.hr
                             Sega@systematics.fido.hr
                    CroLink: Sergej Srepfler (77:500/111)
                    FidoNet: Sergej Srepfler (2:381/114)
*)
{$M 2048,0,4200}
{$G+} {$A+} {$R-} {$S-} {$B-} {$F-} {$L-} {$V-}
{$D-}
(* Next line delete - for test purposes only *)
(* {$define DEBUG} *)
uses dos,crt;
type font=array[1..4100] of byte;
const
   vport:array[1..5] of word=($3c4,$3c4,$3ce,$3ce,$3ce); (* Ports to program *)
   index:array[1..5] of byte=(   2,   4,   4,   5,   6); (* Ports indexes *)
   value:array[1..5] of byte=(   4,   7,   2,   0,   4); (* New values *)

var
   o_val:array[1..5] of byte;
   f:text;
   name,ext,cfg,lin,save1:string;
   p:^font;
   i,j:integer;
   x,y,c,size:byte;
   seg,ofs,b:word;
   l,l1:longint;

{$ifdef DEBUG}
procedure Disp(s:string);
begin
     writeln(s);
     Asm
        MOV AX,0           { Wait for Keystroke }
        int $16
     end;
end;
{$endif}

procedure Get_Cursor_Position(var Column,Row : byte);
var xx,yy:byte;
begin
    Asm
      MOV AH,$0F          {To get active page, returns BH  }
      INT $10
      MOV AH,$3           {Equiv of XX:=WhereX, YY:=WhereY }
      INT $10
      MOV xx,DH
      MOV yy,DL
    end;
    Column:=yy;
    Row:=xx;
end;

procedure Goto_XY(xx,yy:byte);
begin
    Asm
      MOV AH,$0F          {To get active page, returns BH  }
      INT $10
      MOV AH,$02          {XX,YY just like GotoXY(XX,YY)   }
      MOV DL,xx
      MOV DH,yy
      INT $10
    end;
end;

procedure Get_XY(var c:byte);
var cc:byte;
begin
     asm
       MOV AH,$0F
       INT $10
       MOV AH,08
       INT $10
       MOV cc,AL
     end;
     c:=cc;
end;

procedure Execute;
begin
        new(p);                           (* Create space for data *)
        for i:= 1 to 5 do begin           (* Save old values *)
            port[vport[i]]:=index[i];
            o_val[i]:=port[1+vport[i]];
        end;
        for i:= 1 to 5 do begin           (* Programm new values *)
            port[vport[i]]:=index[i];
            port[1+vport[i]]:=value[i];
        end;
        for i:=0 to 255 do begin          (* Save font to memory *)
            for j:=0 to size do
                p^[i*size+j]:=mem[$a000:i*32+j];
        end;
        for i:= 1 to 5 do begin           (* Restore old values *)
            port[vport[i]]:=index[i];
            port[1+vport[i]]:=o_val[i];
        end;

        i:=pos('.',name);
        ext:=copy(name,i,length(name)-i+1);
        cfg:=paramstr(0);
        i:=length(cfg);
        repeat
        dec(i);
        until cfg[i]='.';
        cfg[0]:=chr(i);
        cfg:=cfg+'cfg';
        assign(f,cfg);
        reset(f);
        repeat
             readln(f,lin);
             readln(f,cfg);
             if lin=ext then begin
                {$ifdef DEBUG }
                    Disp('Execute: '+cfg+' '+name);
                {$endif}
                swapvectors;
                exec(cfg,name);
                swapvectors;
                if doserror=8 then begin
                   Writeln('ERROR!!!');
                end;
             end;
        until eof(f);
        close(f);

        for i:= 1 to 5 do begin             (* Programm new values *)
            port[vport[i]]:=index[i];
            port[1+vport[i]]:=value[i];
        end;
        for i:=0 to 255 do begin            (* Restore old font *)
            for j:=0 to size do
                mem[$a000:i*32+j]:=p^[i*size+j];
        end;
        for i:= 1 to 5 do begin             (* Restore old values *)
            port[vport[i]]:=index[i];
            port[1+vport[i]]:=o_val[i];
        end;
        dispose(p);                         (* Free memory *)
end;

(* **************************
        Main program
   **************************
*)
begin
     DirectVideo:= False;
     size:=mem[0:$485];            (* Font size *)
     name:=paramstr(1);
     if pos('MEM',name)=2 then begin
        (* Convert ASCII to longint *)
        l:=0;
        for i:=5 to 14 do begin
            l:=l*10;
            l1:=ord(name[i])-ord('0');
            l:=l+l1;
        end;
        (* Get segment & offset *)
        seg:=l div longint(65536);
        ofs:=(l mod longint(65536));
        (* Read name from NC resident portion *)
        i:=0;
        repeat
        inc(i);
        b:=ofs+i;
        name[i]:=chr(mem[seg:b]);
        until name[i]=chr(0);
        name[0]:=chr(i-1);
     end
     else begin
        {$ifdef DEBUG }
            Disp('Runned from Command line.');
        {$endif}
        execute;
        writeln;
        writeln('Viewer by Sergej repfler (c) 1995 Ver 0.4');
        exit;
     end;
     (* From now on, parameters are in name variable *)
     Get_Cursor_Position(x,y);
     Goto_XY(x,y+2);
     Get_XY(c);
     Goto_XY(x,y);
     (* If runned from NC, there should be a double line frame.
        With graphical commands frame is little diferent
        Check for frame to be sure this is normal view.
        If frame isn't there, it is a Quick View from NC.
        Will work with 25 and 50 rows.
     *)
     if ((c=205) OR (c=202)) then begin
        {$ifdef DEBUG }
            Disp('Runned from NC.');
        {$endif}
        execute;
     end
     else begin
       (* What to do if runned for Quick View *)
          {$ifdef DEBUG }
              Disp('Runned for Quick View.');
          {$endif}
          Goto_XY(x+4,4);
          writeln('File: ',name);
          Goto_XY(x+4,6);
          writeln('Press F3 to view');
          Goto_XY(x,y);
     end;
end.
